commit 443943b362c5fcb55151a8dd2cd36e09cd74d401
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Sun Oct 5 19:25:25 2008 +0200

    [evol] update schema

diff --git a/db/schema.rb b/db/schema.rb
index ed363cd..e91ded8 100644
--- a/db/schema.rb
+++ b/db/schema.rb
@@ -1,5 +1,5 @@
 # This file is auto-generated from the current state of the database. Instead of editing this file, 
-# please use the migrations feature of ActiveRecord to incrementally modify your database, and
+# please use the migrations feature of Active Record to incrementally modify your database, and
 # then regenerate this schema definition.
 #
 # Note that this schema.rb definition is the authoritative source for your database schema. If you need
@@ -9,93 +9,119 @@
 #
 # It's strongly recommended to check this file into your version control system.
 
-ActiveRecord::Schema.define() do
+ActiveRecord::Schema.define(:version => 0) do
 
-  create_table "conditions", :force => true do |t|
+  create_table "artwork_conditions", :force => true do |t|
     t.string  "name",     :limit => 64, :null => false
-    t.integer "position",               :null => false
+    t.integer "position", :limit => 11, :null => false
   end
 
-  add_index "conditions", ["name"], :name => "nom", :unique => true
+  add_index "artwork_conditions", ["name"], :name => "nom", :unique => true
 
-  create_table "exhibition_work", :force => true do |t|
-    t.integer "exhibition_id", :limit => 20, :null => false
-    t.integer "work_id",       :limit => 20, :null => false
-    t.integer "position",      :limit => 20, :null => false
-  end
-
-  add_index "exhibition_work", ["exhibition_id", "work_id"], :name => "exhibition_id", :unique => true
-
-  create_table "exhibitions", :force => true do |t|
-    t.string   "name",       :limit => 128,                    :null => false
-    t.date     "start",                                        :null => false
-    t.date     "end",                                          :null => false
-    t.string   "place",      :limit => 128,                    :null => false
-    t.boolean  "hidden",                    :default => false, :null => false
-    t.integer  "work_id",    :limit => 20,                     :null => false
-    t.datetime "created_at"
-    t.datetime "updated_at"
-  end
-
-  add_index "exhibitions", ["name"], :name => "nom", :unique => true
-  add_index "exhibitions", ["name"], :name => "nom_2"
-
-  create_table "groups", :force => true do |t|
-    t.string   "name",       :limit => 128, :null => false
-    t.integer  "set_id",                    :null => false
+  create_table "artwork_groups", :force => true do |t|
+    t.string   "name",           :limit => 128, :null => false
+    t.integer  "artwork_set_id", :limit => 11,  :null => false
     t.datetime "created_at"
     t.datetime "updated_at"
+    t.text     "comment"
   end
 
-  add_index "groups", ["name"], :name => "nom", :unique => true
-  add_index "groups", ["name"], :name => "nom_2"
+  add_index "artwork_groups", ["name"], :name => "nom", :unique => true
+  add_index "artwork_groups", ["name"], :name => "nom_2"
 
-  create_table "materials", :force => true do |t|
+  create_table "artwork_materials", :force => true do |t|
     t.string "name", :limit => 128, :null => false
   end
 
-  add_index "materials", ["name"], :name => "nom", :unique => true
-  add_index "materials", ["name"], :name => "nom_2"
+  add_index "artwork_materials", ["name"], :name => "nom", :unique => true
+  add_index "artwork_materials", ["name"], :name => "nom_2"
 
-  create_table "placereasons", :force => true do |t|
+  create_table "artwork_placement_reasons", :force => true do |t|
     t.string "name", :limit => 64, :null => false
   end
 
-  add_index "placereasons", ["name"], :name => "nom", :unique => true
+  add_index "artwork_placement_reasons", ["name"], :name => "nom", :unique => true
 
-  create_table "sets", :force => true do |t|
+  create_table "artwork_sets", :force => true do |t|
     t.string   "name",       :limit => 128, :null => false
     t.datetime "created_at"
     t.datetime "updated_at"
+    t.text     "comment"
   end
 
-  add_index "sets", ["name"], :name => "nom", :unique => true
-  add_index "sets", ["name"], :name => "nom_2"
+  add_index "artwork_sets", ["name"], :name => "nom", :unique => true
+  add_index "artwork_sets", ["name"], :name => "nom_2"
 
-  create_table "sizes", :force => true do |t|
+  create_table "artwork_sizes", :force => true do |t|
     t.float   "height",                      :null => false
     t.float   "width",                       :null => false
     t.boolean "standard", :default => false, :null => false
   end
 
-  add_index "sizes", ["height", "width"], :name => "proportion", :unique => true
+  add_index "artwork_sizes", ["height", "width"], :name => "proportion", :unique => true
 
-  create_table "steps", :force => true do |t|
-    t.string   "image_filename", :limit => 256, :null => false
-    t.date     "date",                          :null => false
-    t.integer  "work_id",        :limit => 20,  :null => false
+  create_table "artwork_steps", :force => true do |t|
+    t.string   "filename",     :limit => 512, :null => false
+    t.date     "date"
+    t.integer  "artwork_id",   :limit => 20
     t.datetime "created_at"
     t.datetime "updated_at"
+    t.integer  "size",         :limit => 20,  :null => false
+    t.string   "content_type", :limit => 64,  :null => false
+    t.integer  "height",       :limit => 11,  :null => false
+    t.integer  "width",        :limit => 11,  :null => false
+    t.integer  "parent_id",    :limit => 20
+    t.string   "thumbnail",    :limit => 64
+    t.string   "type",         :limit => 64,  :null => false
+    t.string   "comment",      :limit => 512
   end
 
-  add_index "steps", ["image_filename"], :name => "image_filename", :unique => true
+  add_index "artwork_steps", ["filename"], :name => "image_filename", :unique => true
+
+  create_table "artworks", :force => true do |t|
+    t.integer  "artwork_set_id",              :limit => 20
+    t.string   "artwork_set_position",        :limit => 32
+    t.integer  "artwork_group_id",            :limit => 20
+    t.string   "artwork_group_position",      :limit => 32
+    t.string   "title",                       :limit => 256, :null => false
+    t.integer  "artwork_material_id",         :limit => 10,  :null => false
+    t.integer  "artwork_size_id",             :limit => 10,  :null => false
+    t.integer  "artwork_condition_id",        :limit => 10,  :null => false
+    t.integer  "artwork_placement_reason_id", :limit => 10
+    t.string   "placement_location",          :limit => 256
+    t.date     "placement_date"
+    t.text     "comment"
+    t.datetime "created_at"
+    t.datetime "updated_at"
+  end
 
-  create_table "technique_work", :force => true do |t|
+  create_table "artworks_techniques", :force => true do |t|
     t.integer "technique_id", :limit => 10, :null => false
-    t.integer "work_id",      :limit => 20, :null => false
+    t.integer "artwork_id",   :limit => 20, :null => false
+  end
+
+  add_index "artworks_techniques", ["technique_id", "artwork_id"], :name => "technique_id", :unique => true
+
+  create_table "exhibition_artwork", :force => true do |t|
+    t.integer "exhibition_id", :limit => 20, :null => false
+    t.integer "artwork_id",    :limit => 20, :null => false
+    t.integer "position",      :limit => 20, :null => false
+  end
+
+  add_index "exhibition_artwork", ["exhibition_id", "artwork_id"], :name => "exhibition_id", :unique => true
+
+  create_table "exhibitions", :force => true do |t|
+    t.string   "name",       :limit => 128,                    :null => false
+    t.date     "start",                                        :null => false
+    t.date     "end",                                          :null => false
+    t.string   "place",      :limit => 128,                    :null => false
+    t.boolean  "hidden",                    :default => false, :null => false
+    t.datetime "created_at"
+    t.datetime "updated_at"
   end
 
-  add_index "technique_work", ["technique_id", "work_id"], :name => "technique_id", :unique => true
+  add_index "exhibitions", ["name"], :name => "nom", :unique => true
+  add_index "exhibitions", ["name"], :name => "nom_2"
 
   create_table "techniques", :force => true do |t|
     t.string "name",    :limit => 128, :null => false
@@ -105,19 +131,4 @@ ActiveRecord::Schema.define() do
   add_index "techniques", ["name", "acronym"], :name => "nom", :unique => true
   add_index "techniques", ["name"], :name => "nom_2"
 
-  create_table "works", :force => true do |t|
-    t.integer  "set_id",         :limit => 20
-    t.integer  "group_id",       :limit => 20
-    t.string   "title",          :limit => 256, :null => false
-    t.integer  "material_id",    :limit => 10,  :null => false
-    t.integer  "size_id",        :limit => 10,  :null => false
-    t.integer  "condition_id",   :limit => 10,  :null => false
-    t.integer  "placereason_id", :limit => 10
-    t.string   "place",          :limit => 256
-    t.date     "placedate"
-    t.text     "comment"
-    t.datetime "created_at"
-    t.datetime "updated_at"
-  end
-
 end