commit eb7dd563104eddf48babd9941e84df0302650845
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Sun Jan 24 20:56:20 2010 +0100

    [fix] corrected french typos (closes #19)

diff --git a/po/MyCyma.pot b/po/MyCyma.pot
index aa52cd8..bc563b6 100644
--- a/po/MyCyma.pot
+++ b/po/MyCyma.pot
@@ -6,8 +6,8 @@
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: MyCyma 0.1.0\n"
-"POT-Creation-Date: 2009-06-06 02:43+0200\n"
+"Project-Id-Version: MyCyma 0.2.0\n"
+"POT-Creation-Date: 2010-01-24 20:55+0100\n"
 "PO-Revision-Date: 2008-07-28 02:17+0200\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -322,37 +322,37 @@ msgstr ""
 msgid "New %s"
 msgstr ""
 
-#: app/helpers/application_helper.rb:136
+#: app/helpers/application_helper.rb:134
 msgid "Cancel"
 msgstr ""
 
-#: app/helpers/application_helper.rb:150
+#: app/helpers/application_helper.rb:148
 msgid "Alert !"
 msgstr ""
 
-#: app/helpers/application_helper.rb:185
+#: app/helpers/application_helper.rb:183
 #: app/views/admin/artwork_sizes/index.rhtml:7
 msgid "Yes"
 msgstr ""
 
-#: app/helpers/application_helper.rb:185
+#: app/helpers/application_helper.rb:183
 #: app/views/admin/artwork_sizes/index.rhtml:7
 msgid "No"
 msgstr ""
 
-#: app/helpers/application_helper.rb:206 app/helpers/application_helper.rb:210
+#: app/helpers/application_helper.rb:204 app/helpers/application_helper.rb:208
 msgid "Comment:"
 msgstr ""
 
-#: app/helpers/application_helper.rb:206
+#: app/helpers/application_helper.rb:204
 msgid "<br/>(with %s<br/>formating)"
 msgstr ""
 
-#: app/helpers/application_helper.rb:214
+#: app/helpers/application_helper.rb:212
 msgid "Created at:"
 msgstr ""
 
-#: app/helpers/application_helper.rb:215
+#: app/helpers/application_helper.rb:213
 msgid "Updated at:"
 msgstr ""
 
@@ -523,25 +523,26 @@ msgstr ""
 msgid "EXIF Infos"
 msgstr ""
 
-#: app/views/admin/artwork_step_images/show.rhtml:20
+#: app/views/admin/artwork_step_images/show.rhtml:21
+#: app/views/admin/artwork_step_images/show.rhtml:26
 msgid "No EXIF infos"
 msgstr ""
 
-#: app/views/admin/artwork_step_images/show.rhtml:25
+#: app/views/admin/artwork_step_images/show.rhtml:29
 msgid "Artwork Step Status"
 msgstr ""
 
-#: app/views/admin/artwork_step_images/show.rhtml:27
+#: app/views/admin/artwork_step_images/show.rhtml:31
 #: app/views/admin/artworks/show.rhtml:44
 msgid "Entry First Created:"
 msgstr ""
 
-#: app/views/admin/artwork_step_images/show.rhtml:28
+#: app/views/admin/artwork_step_images/show.rhtml:32
 #: app/views/admin/artworks/show.rhtml:45
 msgid "Entry Last Updated:"
 msgstr ""
 
-#: app/views/admin/artwork_step_images/show.rhtml:34
+#: app/views/admin/artwork_step_images/show.rhtml:38
 msgid "Display all steps"
 msgstr ""
 
diff --git a/po/fr/MyCyma.po b/po/fr/MyCyma.po
index f1a07db..7e9c8a5 100644
--- a/po/fr/MyCyma.po
+++ b/po/fr/MyCyma.po
@@ -6,8 +6,8 @@
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: MyCyma 0.1.0\n"
-"POT-Creation-Date: 2009-06-06 02:43+0200\n"
+"Project-Id-Version: MyCyma 0.2.0\n"
+"POT-Creation-Date: 2010-01-24 20:55+0100\n"
 "PO-Revision-Date: 2008-07-28 02:17+0200\n"
 "Last-Translator: Marc Dequènes (Duck) <Duck@DuckCorp.org>\n"
 "MIME-Version: 1.0\n"
@@ -321,37 +321,37 @@ msgstr "Placer en dernier"
 msgid "New %s"
 msgstr "Nouveau/Nouvelle %s"
 
-#: app/helpers/application_helper.rb:136
+#: app/helpers/application_helper.rb:134
 msgid "Cancel"
 msgstr "Annuler"
 
-#: app/helpers/application_helper.rb:150
+#: app/helpers/application_helper.rb:148
 msgid "Alert !"
 msgstr "Alerte !"
 
-#: app/helpers/application_helper.rb:185
+#: app/helpers/application_helper.rb:183
 #: app/views/admin/artwork_sizes/index.rhtml:7
 msgid "Yes"
 msgstr "Oui"
 
-#: app/helpers/application_helper.rb:185
+#: app/helpers/application_helper.rb:183
 #: app/views/admin/artwork_sizes/index.rhtml:7
 msgid "No"
 msgstr "Non"
 
-#: app/helpers/application_helper.rb:206 app/helpers/application_helper.rb:210
+#: app/helpers/application_helper.rb:204 app/helpers/application_helper.rb:208
 msgid "Comment:"
 msgstr "Commentaire :"
 
-#: app/helpers/application_helper.rb:206
+#: app/helpers/application_helper.rb:204
 msgid "<br/>(with %s<br/>formating)"
 msgstr "<br/>(avec du<br/> formatage %s)"
 
-#: app/helpers/application_helper.rb:214
+#: app/helpers/application_helper.rb:212
 msgid "Created at:"
 msgstr "Créé(e) le :"
 
-#: app/helpers/application_helper.rb:215
+#: app/helpers/application_helper.rb:213
 msgid "Updated at:"
 msgstr "Mis(e) à jour le :"
 
@@ -525,25 +525,26 @@ msgstr "Taille du Fichier :"
 msgid "EXIF Infos"
 msgstr "Infos EXIF :"
 
-#: app/views/admin/artwork_step_images/show.rhtml:20
+#: app/views/admin/artwork_step_images/show.rhtml:21
+#: app/views/admin/artwork_step_images/show.rhtml:26
 msgid "No EXIF infos"
 msgstr "pas d'infos EXIF"
 
-#: app/views/admin/artwork_step_images/show.rhtml:25
+#: app/views/admin/artwork_step_images/show.rhtml:29
 msgid "Artwork Step Status"
 msgstr "État de l'Étape"
 
-#: app/views/admin/artwork_step_images/show.rhtml:27
+#: app/views/admin/artwork_step_images/show.rhtml:31
 #: app/views/admin/artworks/show.rhtml:44
 msgid "Entry First Created:"
 msgstr "Entrée Initialement Créée :"
 
-#: app/views/admin/artwork_step_images/show.rhtml:28
+#: app/views/admin/artwork_step_images/show.rhtml:32
 #: app/views/admin/artworks/show.rhtml:45
 msgid "Entry Last Updated:"
 msgstr "Entrée Dernièrement Mise à jour :"
 
-#: app/views/admin/artwork_step_images/show.rhtml:34
+#: app/views/admin/artwork_step_images/show.rhtml:38
 msgid "Display all steps"
 msgstr "Afficher toutes les étapes"
 
@@ -551,7 +552,7 @@ msgstr "Afficher toutes les étapes"
 #: app/views/admin/artworks/show.rhtml:39
 #: app/views/admin/artworks/_form.rhtml:37
 msgid "Date:"
-msgstr "Date "
+msgstr "Date :"
 
 #: app/views/admin/artwork_step_images/_form.rhtml:8
 msgid "Image:"
@@ -979,7 +980,7 @@ msgstr "Cet ensemble fait partie de la série '%s'"
 
 #: app/views/view/group.rhtml:7 app/views/view/set.rhtml:11
 msgid "Artworks:"
-msgstr "Œuvres:"
+msgstr "Œuvres :"
 
 #: app/views/view/tree.rhtml:1
 msgid "Tree view of the Cyma"
@@ -1003,7 +1004,7 @@ msgstr "Vue de la série '%s'"
 
 #: app/views/view/set.rhtml:3
 msgid "Groups:"
-msgstr "Ensembles:"
+msgstr "Ensembles :"
 
 #: lib/mycyma.rb:32
 msgid "Browser preference"